import { ComputeArrayNode } from '@compute.ts/array';
import { ComputeBooleanNode } from '@compute.ts/boolean';
import { ComputeDateNode } from '@compute.ts/date';
import { ComputeDictionaryNode } from '@compute.ts/dictionary';
import { ComputeNumberNode } from '@compute.ts/number';
import { ComputeStringNode } from '@compute.ts/string';
import { FunctionNoArry } from '../nodes/FunctionNoArry';
import { Take0ArgReturn } from '../returns/Take0ArgReturn';
import { Take1Arg } from './Take1Arg';
export declare class Take0Arg {
    get takeBoolean(): Take1Arg<ComputeBooleanNode, boolean>;
    get takeNumber(): Take1Arg<ComputeNumberNode, number>;
    get takeString(): Take1Arg<ComputeStringNode, string>;
    get takeDate(): Take1Arg<ComputeDateNode, Date>;
    get takeBooleanArray(): Take1Arg<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get takeNumberArray(): Take1Arg<ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get takeStringArray(): Take1Arg<ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get takeDateArray(): Take1Arg<ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get takeDictionaryOfBoolean(): Take1Arg<ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get takeDictionaryOfNumber(): Take1Arg<ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get takeDictionaryOfString(): Take1Arg<ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get takeDictionaryOfDate(): Take1Arg<ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get takeDictionaryOfBooleanArray(): Take1Arg<ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get takeDictionaryOfNumberArray(): Take1Arg<ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get takeDictionaryOfStringArray(): Take1Arg<ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get takeDictionaryOfDateArray(): Take1Arg<ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
    get returnBoolean(): Take0ArgReturn<FunctionNoArry<ComputeBooleanNode, boolean>, ComputeBooleanNode, boolean>;
    get returnNumber(): Take0ArgReturn<FunctionNoArry<ComputeNumberNode, number>, ComputeNumberNode, number>;
    get returnString(): Take0ArgReturn<FunctionNoArry<ComputeStringNode, string>, ComputeStringNode, string>;
    get returnDate(): Take0ArgReturn<FunctionNoArry<ComputeDateNode, Date>, ComputeDateNode, Date>;
    get returnArrayOfBoolean(): Take0ArgReturn<FunctionNoArry<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get returnArrayOfNumber(): Take0ArgReturn<FunctionNoArry<ComputeArrayNode<ComputeNumberNode, number>, number[]>, ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get returnArrayOfString(): Take0ArgReturn<FunctionNoArry<ComputeArrayNode<ComputeStringNode, string>, string[]>, ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get returnArrayOfDate(): Take0ArgReturn<FunctionNoArry<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get returnDictionaryOfBoolean(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get returnDictionaryOfNumber(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get returnDictionaryOfString(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get returnDictionaryOfDate(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get returnDictionaryOfBooleanArray(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get returnDictionaryOfNumberArray(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get returnDictionaryOfStringArray(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get returnDictionaryOfDateArray(): Take0ArgReturn<FunctionNoArry<ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
}
