import { ComputeArrayNode } from '@compute.ts/array';
import { ComputeBooleanNode } from '@compute.ts/boolean';
import { ComputeApiNode } from '@compute.ts/core';
import { ComputeDateNode } from '@compute.ts/date';
import { ComputeDictionaryNode } from '@compute.ts/dictionary';
import { ComputeNumberNode } from '@compute.ts/number';
import { ComputeStringNode } from '@compute.ts/string';
import { FunctionUnary } from '../nodes/FunctionUnary';
import { Take1ArgReturn } from '../returns/Take1ArgReturn';
import { Take2Arg } from './Take2Arg';
export declare class Take1Arg<ARG_NODE_TYPE extends ComputeApiNode<ARG>, ARG> {
    private nodifier;
    constructor(nodifier: (args: ARG_NODE_TYPE | ARG) => ARG_NODE_TYPE);
    get takeBoolean(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeBooleanNode, boolean>;
    get takeNumber(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeNumberNode, number>;
    get takeString(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeStringNode, string>;
    get takeDate(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDateNode, Date>;
    get takeBooleanArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get takeNumberArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get takeStringArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get takeDateArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get takeDictionaryOfBoolean(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get takeDictionaryOfNumber(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get takeDictionaryOfString(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get takeDictionaryOfDate(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get takeDictionaryOfBooleanArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get takeDictionaryOfNumberArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get takeDictionaryOfStringArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get takeDictionaryOfDateArray(): Take2Arg<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
    get returnBoolean(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeBooleanNode, boolean>, ComputeBooleanNode, boolean>;
    get returnNumber(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeNumberNode, number>, ComputeNumberNode, number>;
    get returnString(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeStringNode, string>, ComputeStringNode, string>;
    get returnDate(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDateNode, Date>, ComputeDateNode, Date>;
    get returnArrayOfBoolean(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get returnArrayOfNumber(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeNumberNode, number>, number[]>, ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get returnArrayOfString(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeStringNode, string>, string[]>, ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get returnArrayOfDate(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeArrayNode<ComputeDateNode, Date>, Date[]>, ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get returnDictionaryOfBoolean(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get returnDictionaryOfNumber(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get returnDictionaryOfString(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get returnDictionaryOfDate(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get returnDictionaryOfBooleanArray(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get returnDictionaryOfNumberArray(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get returnDictionaryOfStringArray(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get returnDictionaryOfDateArray(): Take1ArgReturn<ARG_NODE_TYPE, ARG, FunctionUnary<ARG_NODE_TYPE, ARG, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
}
