import { ComputeArrayNode } from '@compute.ts/array';
import { ComputeBooleanNode } from '@compute.ts/boolean';
import { ComputeApiNode } from '@compute.ts/core';
import { ComputeDateNode } from '@compute.ts/date';
import { ComputeDictionaryNode } from '@compute.ts/dictionary';
import { ComputeNumberNode } from '@compute.ts/number';
import { ComputeStringNode } from '@compute.ts/string';
import { FunctionBinary } from '../nodes/FunctionBinary';
import { Take2ArgReturn } from '../returns/Take2ArgReturn';
import { Take3Arg } from './Take3Arg';
export declare class Take2Arg<ARG_A_NODE_TYPE extends ComputeApiNode<ARG_A>, ARG_A, ARG_B_NODE_TYPE extends ComputeApiNode<ARG_B>, ARG_B> {
    private nodifierA;
    private nodifierB;
    constructor(nodifierA: (args: ARG_A_NODE_TYPE | ARG_A) => ARG_A_NODE_TYPE, nodifierB: (args: ARG_B_NODE_TYPE | ARG_B) => ARG_B_NODE_TYPE);
    get takeBoolean(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeBooleanNode, boolean>;
    get takeNumber(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeNumberNode, number>;
    get takeString(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeStringNode, string>;
    get takeDate(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDateNode, Date>;
    get takeBooleanArray(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get takeNumberArray(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get takeStringArray(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get takeDateArray(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get takeDictionaryOfBoolean(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get takeDictionaryOfNumber(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get takeDictionaryOfString(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get takeDictionaryOfDate(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get takeDictionaryOfArrayOfBoolean(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get takeDictionaryOfArrayOfNumber(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get takeDictionaryOfArrayOfString(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get takeDictionaryOfArrayOfDate(): Take3Arg<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
    get returnBoolean(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeBooleanNode, boolean>, ComputeBooleanNode, boolean>;
    get returnNumber(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeNumberNode, number>, ComputeNumberNode, number>;
    get returnString(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeStringNode, string>, ComputeStringNode, string>;
    get returnDate(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDateNode, Date>, ComputeDateNode, Date>;
    get returnBooleanArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get returnNumberArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeNumberNode, number>, number[]>, ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get returnStringArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeStringNode, string>, string[]>, ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get returnDateArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeArrayNode<ComputeDateNode, Date>, Date[]>, ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get returnDictionaryOfBoolean(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get returnDictionaryOfNumber(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get returnDictionaryOfString(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get returnDictionaryOfDate(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get returnDictionaryOfBooleanArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get returnDictionaryOfNumberArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get returnDictionaryOfStringArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get returnDictionaryOfDateArray(): Take2ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, FunctionBinary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
}
