import { ComputeArrayNode } from '@compute.ts/array';
import { ComputeBooleanNode } from '@compute.ts/boolean';
import { ComputeApiNode } from '@compute.ts/core';
import { ComputeDateNode } from '@compute.ts/date';
import { ComputeDictionaryNode } from '@compute.ts/dictionary';
import { ComputeNumberNode } from '@compute.ts/number';
import { ComputeStringNode } from '@compute.ts/string';
import { FunctionTernary } from '../nodes/FunctionTernary';
import { Take3ArgReturn } from '../returns/Take3ArgReturn';
export declare class Take3Arg<ARG_A_NODE_TYPE extends ComputeApiNode<ARG_A>, ARG_A, ARG_B_NODE_TYPE extends ComputeApiNode<ARG_B>, ARG_B, ARG_C_NODE_TYPE extends ComputeApiNode<ARG_C>, ARG_C> {
    private nodifierA;
    private nodifierB;
    private nodifierC;
    constructor(nodifierA: (args: ARG_A_NODE_TYPE | ARG_A) => ARG_A_NODE_TYPE, nodifierB: (args: ARG_B_NODE_TYPE | ARG_B) => ARG_B_NODE_TYPE, nodifierC: (args: ARG_C_NODE_TYPE | ARG_C) => ARG_C_NODE_TYPE);
    get returnBoolean(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeBooleanNode, boolean>, ComputeBooleanNode, boolean>;
    get returnNumber(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeNumberNode, number>, ComputeNumberNode, number>;
    get returnString(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeStringNode, string>, ComputeStringNode, string>;
    get returnDate(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDateNode, Date>, ComputeDateNode, Date>;
    get returnBooleanArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>;
    get returnNumberArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeArrayNode<ComputeNumberNode, number>, number[]>, ComputeArrayNode<ComputeNumberNode, number>, number[]>;
    get returnStringArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeArrayNode<ComputeStringNode, string>, string[]>, ComputeArrayNode<ComputeStringNode, string>, string[]>;
    get returnDateArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeArrayNode<ComputeDateNode, Date>, Date[]>, ComputeArrayNode<ComputeDateNode, Date>, Date[]>;
    get returnDictionaryOfBoolean(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>, ComputeDictionaryNode<ComputeBooleanNode, boolean>, {
        [key: string]: boolean;
    }>;
    get returnDictionaryOfNumber(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>, ComputeDictionaryNode<ComputeNumberNode, number>, {
        [key: string]: number;
    }>;
    get returnDictionaryOfString(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>, ComputeDictionaryNode<ComputeStringNode, string>, {
        [key: string]: string;
    }>;
    get returnDictionaryOfDate(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>, ComputeDictionaryNode<ComputeDateNode, Date>, {
        [key: string]: Date;
    }>;
    get returnDictionaryOfBooleanArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeBooleanNode, boolean>, boolean[]>, {
        [key: string]: boolean[];
    }>;
    get returnDictionaryOfNumberArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeNumberNode, number>, number[]>, {
        [key: string]: number[];
    }>;
    get returnDictionaryOfStringArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeStringNode, string>, string[]>, {
        [key: string]: string[];
    }>;
    get returnDictionaryOfDateArray(): Take3ArgReturn<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, FunctionTernary<ARG_A_NODE_TYPE, ARG_A, ARG_B_NODE_TYPE, ARG_B, ARG_C_NODE_TYPE, ARG_C, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>, ComputeDictionaryNode<ComputeArrayNode<ComputeDateNode, Date>, Date[]>, {
        [key: string]: Date[];
    }>;
}
